c++-gtk-utils: Cgu::SharedLockHandle< T, Dealloc > Class Template Reference

c++-gtk-utils

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
Cgu::SharedLockHandle< T, Dealloc > Class Template Reference
handles and smart pointers

This is a generic class for managing the lifetime of objects allocated on freestore, with a thread safe reference count.. More...

`#include <c++-gtk-utils/shared_handle.h>`

## Public Member Functions
| SharedLockHandle (T ptr=0)
| SharedLockHandle (T ptr, Cgu::SharedHandleAllocFail::Leave tag)
void | reset (T ptr=0)
void | reset (T ptr, Cgu::SharedHandleAllocFail::Leave tag)
| SharedLockHandle (const SharedLockHandle &sh_hand) noexcept
| SharedLockHandle (SharedLockHandle &&sh_hand) noexcept
SharedLockHandle & | operator= (SharedLockHandle sh_hand)
T | get () const noexcept
| operator T () const noexcept
unsigned int | get_refcount () const noexcept
| ~SharedLockHandle ()

## Detailed Description

### template<class T, class Dealloc = StandardArrayDelete<T>>
class Cgu::SharedLockHandle< T, Dealloc >

This is a generic class for managing the lifetime of objects allocated on freestore, with a thread safe reference count..

See Also
  SharedHandle ScopedHandle SharedHandleError
  StandardArrayDelete CFree GFree GerrorFree GSliceFree GSliceFreeSize GSliceDestroy

Class SharedLockHandle is a version of the SharedHandle class which includes synchronization so that it can handle objects accessed in multiple threads (although the word Lock is in the title, by default it uses glib atomic functions to access the reference count rather than a mutex, so the overhead should be very small). Note that only the reference count is protected, so this is thread safe in the sense in which a raw pointer is thread safe. A shared handle accessed in one thread referencing a particular object is thread safe as against another shared handle accessing the same object in a different thread. It is thus suitable for use in different standard C++ containers which exist in different threads but which contain shared objects by reference. But:

1. If the referenced object is to be modified in one thread and read or modified in another thread an appropriate mutex for the referenced object is required (unless that referenced object does its own locking).
2. If the same instance of shared handle is to be modified in one thread (by assigning to the handle so that it references a different object, or by moving from it), and copied (assigned from or used as the argument of a copy constructor), accessed, destroyed or modified in another thread, a mutex for that instance of shared handle is required.
3. Objects referenced by shared handles which are objects for which POSIX provides no guarantees (in the main, those which are not built-in types), such as strings and similar containers, may not support concurrent reads in different threads. That depends on the library implementation concerned. If that is the case, a mutex for the referenced object will also be required when reading any given instance of such an object in more than one thread by dereferencing any shared handles referencing it (and indeed, when not using shared handles at all).

SharedLockHandle objects can be instantiated for pointers to constant objects (such as SharedLockHandle<const char*>), provided the deleter functor will take such pointers.

This library provides StandardArrayDelete, CFree, GFree, GerrorFree, GSliceFree, GSliceFreeSize and GSliceDestroy deleter functors, which can be used as the second template parameter of the SharedLockHandle class. StandardArrayDelete is the default.

As mentioned, by default glib atomic functions are used to provide thread-safe manipulation of the reference count. However, the symbol CGU_SHARED_LOCK_HANDLE_USE_MUTEX can be defined so that the library uses mutexes instead, which might be useful for some debugging purposes. Note that if CGU_SHARED_LOCK_HANDLE_USE_MUTEX is to be defined, this is best done by textually amending the shared_handle.h header file before the library is compiled. This will ensure that everything in the program and the library which includes the shared_handle.h header is guaranteed to see the same definitions so that the C++ standard's one-definition-rule is complied with.

Comparison with std::shared_ptr

Although the semantics of std::shared_ptr in C++11/14 are not particularly suited to managing either arrays or C objects with accessor functions (such as in glib), most of the things that can be done by this class can be done by using std::shared_ptr with a specialised deleter. However, this class is retained in the c++-gtk-utils library not only to retain compatibility with series 1.2 of the library, but also to cater for some cases not met (or not so easily met) by std::shared_ptr:

1. The Cgu::SharedLockHandle class takes its deleter as a template parameter, which means that typedefs can be used to enable handles for particular deleters to be easily created (and as mentioned, this library provides a number of pre-formed deleter functors and typedefs for them). With std::shared_ptr, custom deleters must be passed to the shared_ptr constructor on every occasion a shared_ptr is constructed to manage a new object (and they cannot be templated as a typedef).
2. Glib memory slices provide an efficient small object allocator (they are likely to be significantly more efficient than global operator new()/new[](), which generally hand off to malloc(), and whilst malloc() is good for large block allocations it is generally poor as a small object allocator). Internal Cgu::SharedLockHandle allocation using glib memory slices can be achieved by compiling the library with the --with-glib-memory-slices-no-compat configuration option.
3. If glib memory slices are not used (which do not throw), constructing a shared pointer for a new managed object (or calling reset() for a new managed object) might throw if internal allocation fails. Although by default the Cgu::SharedLockHandle implementation will delete the new managed object in such a case, it also provides an alternative constructor and reset() method which instead enable the new object to be accessed via the thrown exception object so that user code can decide what to do; std::shared_ptr deletes the new object in every case.
4. A user can explicitly state whether the shared handle object is to have atomic increment and decrement-and-test with respect to the reference count so that the reference count is thread safe ('no' in the case of Cgu::SharedHandle, and 'yes' in the case of Cgu::SharedLockHandle). Using atomic functions is unnecessary if the managed object concerned is only addressed in one thread (and might cause unwanted cache flushing in certain circumstances). std::shared_ptr will generally always use atomic functions with respect to its reference count in a multi-threaded program.

In favour of std::shared_ptr, it has an associated std::weak_ptr class, which Cgu::SharedLockHandle does not (there is a Cgu::GobjWeakHandle class, but that is cognate with Cgu::GobjHandle and is only usable with GObjects). In addition shared_ptr objects have some atomic store, load and exchange functions provided for them which enable concurrent modifications of the same instance of shared_ptr in different threads to have defined results.

If the library is compiled with the --with-glib-memory-slices-no-compat configuration option, as mentioned Cgu::SharedLockHandle constructs its reference counting internals using glib memory slices. Although it is safe in a multi-threaded program if glib < 2.32 is installed to construct a static SharedLockHandle object in global namespace (that is, prior to g_thread_init() being called) by means of the default constructor and/or a pointer argument of NULL, it is not safe if constructed with a non-NULL pointer value. If glib >= 2.32 is installed, global objects with memory slices are safe in all circumstances. (Having said that, it would be highly unusual to have global SharedLockHandle objects.)

## Constructor & Destructor Documentation

template<class T, class Dealloc = StandardArrayDelete<T>>

Cgu::SharedLockHandle< T, Dealloc >::SharedLockHandle | ( | T | ptr = `0`) |  |
| inlineexplicit

Constructor taking an unmanaged object.

Parameters

  ptr | The object which the SharedLockHandle is to manage (if any).

Exceptions

  std::bad_alloc | This constructor will not throw if the 'ptr' argument has a NULL value (the default), otherwise it might throw std::bad_alloc if memory is exhausted and the system throws in that case. If such an exception is thrown, this constructor is exception safe (it does not leak resources), but as well as cleaning itself up this constructor will also delete the managed object passed to it to avoid a memory leak. If such automatic deletion is not wanted in that case, use the version of this constructor taking a Cgu::SharedHandleAllocFail::Leave tag argument.

Note
  1. std::bad_alloc will not be thrown if the library has been installed using the --with-glib-memory-slices-no-compat configuration option: instead glib will terminate the program if it is unable to obtain memory from the operating system.
  2. By default, glib atomic functions are used to provide thread-safe manipulation of the reference count. However, the header file shared_handle.h can be textually amended before the library is compiled to define the symbol CGU_SHARED_LOCK_HANDLE_USE_MUTEX so as to use mutexes instead, which might be useful for some debugging purposes. Were that to be done, Cgu::Thread::MutexError might be thrown by this constructor if initialization of the mutex fails.

template<class T, class Dealloc = StandardArrayDelete<T>>

Cgu::SharedLockHandle< T, Dealloc >::SharedLockHandle | ( | T | ptr,
|  | Cgu::SharedHandleAllocFail::Leave | tag
| ) |  |
| inline

Constructor taking an unmanaged object.

Parameters

  ptr | The object which the SharedLockHandle is to manage.
  tag | Passing the tag emumerator Cgu::SharedHandleAllocFail::leave causes this constructor not to delete the new managed object passed as the 'ptr' argument in the event of internal allocation in this method failing because of memory exhaustion (in that event, Cgu::SharedHandleError will be thrown).

Exceptions

  Cgu::SharedHandleError | This constructor might throw Cgu::SharedHandleError if memory is exhausted and the system would otherwise throw std::bad_alloc in that case. This constructor is exception safe (it does not leak resources), and if such an exception is thrown it will clean itself up, but it will not attempt to delete the new managed object passed to it. Access to the object passed to the 'ptr' argument can be obtained via the thrown Cgu::SharedHandleError object.

Note
  1. On systems with over-commit/lazy-commit combined with virtual memory (swap), it is rarely useful to check for memory exhaustion, so in those cases this version of the constructor will not be useful.
  2. If the library has been installed using the --with-glib-memory-slices-no-compat configuration option this version of the constructor will also not be useful: instead glib will terminate the program if it is unable to obtain memory from the operating system.
  3. By default, glib atomic functions are used to provide thread-safe manipulation of the reference count. However, the header file shared_handle.h can be textually amended before the library is compiled to define the symbol CGU_SHARED_LOCK_HANDLE_USE_MUTEX so as to use mutexes instead, which might be useful for some debugging purposes. Were that to be done, Cgu::SharedHandleError might be thrown by this constructor if initialization of the mutex fails (even if the --with-glib-memory-slices-no-compat configuration option is chosen).

template<class T, class Dealloc = StandardArrayDelete<T>>

Cgu::SharedLockHandle< T, Dealloc >::SharedLockHandle | ( | const SharedLockHandle< T, Dealloc > & | sh_hand) |  |
| inlinenoexcept

The copy constructor does not throw.

Parameters

  sh_hand | The handle to be copied.

template<class T, class Dealloc = StandardArrayDelete<T>>

Cgu::SharedLockHandle< T, Dealloc >::SharedLockHandle | ( | SharedLockHandle< T, Dealloc > && | sh_hand) |  |
| inlinenoexcept

The move constructor does not throw. It has move semantics.

Parameters

  sh_hand | The handle to be moved.

template<class T, class Dealloc = StandardArrayDelete<T>>

Cgu::SharedLockHandle< T, Dealloc >::~SharedLockHandle | ( | ) |  |
| inline

The destructor does not throw unless the destructor of a handled object throws - that should never happen.

## Member Function Documentation

template<class T, class Dealloc = StandardArrayDelete<T>>

T Cgu::SharedLockHandle< T, Dealloc >::get | ( | ) |  | const
| inlinenoexcept

This method does not throw.

Returns
  A pointer to the handled object (or NULL if none is handled).

template<class T, class Dealloc = StandardArrayDelete<T>>

unsigned int Cgu::SharedLockHandle< T, Dealloc >::get_refcount | ( | ) |  | const
| inlinenoexcept

This method does not throw.

Returns
  The number of SharedLockHandle objects referencing the managed object (or 0 if none is managed by this SharedLockHandle).

Note
  The return value may not be valid if another thread has changed the reference count before the value returned by this method is acted on. It is provided as a utility, but may not be meaningful, depending on the intended usage.

template<class T, class Dealloc = StandardArrayDelete<T>>

Cgu::SharedLockHandle< T, Dealloc >::operator T | ( | ) |  | const
| inlinenoexcept

This method does not throw.

Returns
  A pointer to the handled object (or NULL if none is handled).

template<class T, class Dealloc = StandardArrayDelete<T>>

SharedLockHandle& Cgu::SharedLockHandle< T, Dealloc >::operator= | ( | SharedLockHandle< T, Dealloc > | sh_hand) |  |
| inline

This method (and so copy or move assignment) does not throw unless the destructor of a managed object throws.

Parameters

  sh_hand | the assignor.

Returns
  The SharedLockHandle object after assignment.

template<class T, class Dealloc = StandardArrayDelete<T>>

void Cgu::SharedLockHandle< T, Dealloc >::reset | ( | T | ptr = `0`) |  |
| inline

Causes the SharedLockHandle to cease to manage its managed object (if any), deleting it if this is the last ShareLockHandle object managing it. If the argument passed is not NULL, the SharedLockHandle object will manage the new object passed (which must not be managed by any other SharedLockHandle object).

Parameters

  ptr | NULL (the default), or a new unmanaged object to manage.

Exceptions

  std::bad_alloc | This method will not throw if the 'ptr' argument has a NULL value (the default) and the destructor of a managed object does not throw, otherwise it might throw std::bad_alloc if memory is exhausted and the system throws in that case. Note that if such an exception is thrown then this method will do nothing (it is strongly exception safe and will continue to manage the object it was managing prior to the call), except that it will delete the new managed object passed to it to avoid a memory leak. If such automatic deletion in the event of such an exception is not wanted, use the reset() method taking a Cgu::SharedHandleAllocFail::Leave tag type as its second argument.

Note
  1. std::bad_alloc will not be thrown if the library has been installed using the --with-glib-memory-slices-no-compat configuration option: instead glib will terminate the program if it is unable to obtain memory from the operating system.
  2. By default, glib atomic functions are used to provide thread-safe manipulation of the reference count. However, the header file shared_handle.h can be textually amended before the library is compiled to define the symbol CGU_SHARED_LOCK_HANDLE_USE_MUTEX so as to use mutexes instead, which might be useful for some debugging purposes. Were that to be done, Cgu::Thread::MutexError might be thrown by this method if initialization of the mutex fails.
  3. A SharedLockHandle object protects its reference count but not the managed object or its other internals. The reset() method should not be called by one thread in respect of a particular SharedLockHandle object while another thread may be operating on, copying or dereferencing the same instance of SharedLockHandle. It is thread-safe as against another instance of SharedLockHandle managing the same object.

template<class T, class Dealloc = StandardArrayDelete<T>>

void Cgu::SharedLockHandle< T, Dealloc >::reset | ( | T | ptr,
|  | Cgu::SharedHandleAllocFail::Leave | tag
| ) |  |
| inline

Causes the SharedLockHandle to cease to manage its managed object (if any), deleting it if this is the last ShareLockHandle object managing it. The SharedLockHandle object will manage the new object passed (which must not be managed by any other SharedLockHandle object). This method is exception safe, but see the comments below on Cgu::SharedHandleError.

Parameters

  ptr | A new unmanaged object to manage (if no new object is to be managed, use the version of reset() taking a default value of NULL).
  tag | Passing the tag emumerator Cgu::SharedHandleAllocFail::leave causes this method not to delete the new managed object passed as the 'ptr' argument in the event of internal allocation in this method failing because of memory exhaustion (in that event, Cgu::SharedHandleError will be thrown).

Exceptions

  Cgu::SharedHandleError | This method might throw Cgu::SharedHandleError if memory is exhausted and the system would otherwise throw std::bad_alloc in that case. Note that if such an exception is thrown then this method will do nothing (it is strongly exception safe and will continue to manage the object it was managing prior to the call), and it will not attempt to delete the new managed object passed to it (if any). Access to the object passed to the 'ptr' argument can be obtained via the thrown Cgu::SharedHandleError object.

Note
  1. A SharedLockHandle object protects its reference count but not the managed object or its other internals. The reset() method should not be called by one thread in respect of a particular SharedLockHandle object while another thread may be operating on, copying or dereferencing the same instance of SharedLockHandle. It is thread-safe as against another instance of SharedLockHandle managing the same object.
  2. On systems with over-commit/lazy-commit combined with virtual memory (swap), it is rarely useful to check for memory exhaustion, so in those cases this version of the reset() method will not be useful.
  3. If the library has been installed using the --with-glib-memory-slices-no-compat configuration option this version of the reset() method will also not be useful: instead glib will terminate the program if it is unable to obtain memory from the operating system.
  4. By default, glib atomic functions are used to provide thread-safe manipulation of the reference count. However, the header file shared_handle.h can be textually amended before the library is compiled to define the symbol CGU_SHARED_LOCK_HANDLE_USE_MUTEX so as to use mutexes instead, which might be useful for some debugging purposes. Were that to be done, Cgu::SharedHandleError might be thrown by this method if initialization of the mutex fails (even if the --with-glib-memory-slices-no-compat configuration option is chosen).

The documentation for this class was generated from the following file:

- shared_handle.h